src/Web/Pages/Basket/Checkout.cshtml.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.eShopWeb.ApplicationCore.Entities.OrderAggregate;
using Microsoft.eShopWeb.ApplicationCore.Exceptions;
using Microsoft.eShopWeb.ApplicationCore.Interfaces;
using Microsoft.eShopWeb.Infrastructure.Identity;
using Microsoft.eShopWeb.Web.Interfaces;

namespace Microsoft.eShopWeb.Web.Pages.Basket;

[Authorize]
public class CheckoutModel : PageModel
{
    private readonly IBasketService _basketService;
    private readonly SignInManager<ApplicationUser> _signInManager;
    private readonly IOrderService _orderService;
    private string _username = null;
    private readonly IBasketViewModelService _basketViewModelService;
    private readonly IAppLogger<CheckoutModel> _logger;

    public CheckoutModel(IBasketService basketService,
        IBasketViewModelService basketViewModelService,
        SignInManager<ApplicationUser> signInManager,
        IOrderService orderService,
        IAppLogger<CheckoutModel> logger)
    {
        _basketService = basketService;
        _signInManager = signInManager;
        _orderService = orderService;
        _basketViewModelService = basketViewModelService;
        _logger = logger;
    }

    public BasketViewModel BasketModel { get; set; } = new BasketViewModel();

    public async Task OnGet()
    {
        await SetBasketModelAsync();
    }

    public async Task<IActionResult> OnPost(IEnumerable<BasketItemViewModel> items)
    {
        try
        {
            await SetBasketModelAsync();

            if (!ModelState.IsValid)
            {
                return BadRequest();
            }

            var updateModel = items.ToDictionary(b => b.Id.ToString(), b => b.Quantity);
            await _basketService.SetQuantities(BasketModel.Id, updateModel);
            await _orderService.CreateOrderAsync(BasketModel.Id, new Address("123 Main St.", "Kent", "OH", "United States", "44240"));
            await _basketService.DeleteBasketAsync(BasketModel.Id);
        }
        catch (EmptyBasketOnCheckoutException emptyBasketOnCheckoutException)
        {
            //Redirect to Empty Basket page
            _logger.LogWarning(emptyBasketOnCheckoutException.Message);
            return RedirectToPage("/Basket/Index");
        }

        return RedirectToPage("Success");
    }

    private async Task SetBasketModelAsync()
    {
        if (_signInManager.IsSignedIn(HttpContext.User))
        {
            BasketModel = await _basketViewModelService.GetOrCreateBasketForUser(User.Identity.Name);
        }
        else
        {
            GetOrSetBasketCookieAndUserName();
            BasketModel = await _basketViewModelService.GetOrCreateBasketForUser(_username);
        }
    }

    private void GetOrSetBasketCookieAndUserName()
    {
        if (Request.Cookies.ContainsKey(Constants.BASKET_COOKIENAME))
        {
            _username = Request.Cookies[Constants.BASKET_COOKIENAME];
        }
        if (_username != null) return;

        _username = Guid.NewGuid().ToString();
        var cookieOptions = new CookieOptions();
        cookieOptions.Expires = DateTime.Today.AddYears(10);
        Response.Cookies.Append(Constants.BASKET_COOKIENAME, _username, cookieOptions);
    }
}

src/Web/Pages/Basket/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.eShopWeb.ApplicationCore.Interfaces;
using Microsoft.eShopWeb.Web.Interfaces;
using Microsoft.eShopWeb.Web.ViewModels;

namespace Microsoft.eShopWeb.Web.Pages.Basket;

public class IndexModel : PageModel
{
    private readonly IBasketService _basketService;
    private readonly IBasketViewModelService _basketViewModelService;

    public IndexModel(IBasketService basketService,
        IBasketViewModelService basketViewModelService)
    {
        _basketService = basketService;
        _basketViewModelService = basketViewModelService;
    }

    public BasketViewModel BasketModel { get; set; } = new BasketViewModel();

    public async Task OnGet()
    {
        BasketModel = await _basketViewModelService.GetOrCreateBasketForUser(GetOrSetBasketCookieAndUserName());
    }

    public async Task<IActionResult> OnPost(CatalogItemViewModel productDetails)
    {
        if (productDetails?.Id == null)
        {
            return RedirectToPage("/Index");
        }

        var username = GetOrSetBasketCookieAndUserName();
        var basket = await _basketService.AddItemToBasket(username,
            productDetails.Id, productDetails.Price);

        BasketModel = await _basketViewModelService.Map(basket);

        return RedirectToPage();
    }

    public async Task OnPostUpdate(IEnumerable<BasketItemViewModel> items)
    {
        if (!ModelState.IsValid)
        {
            return;
        }

        var basketView = await _basketViewModelService.GetOrCreateBasketForUser(GetOrSetBasketCookieAndUserName());
        var updateModel = items.ToDictionary(b => b.Id.ToString(), b => b.Quantity);
        var basket = await _basketService.SetQuantities(basketView.Id, updateModel);
        BasketModel = await _basketViewModelService.Map(basket);
    }

    private string GetOrSetBasketCookieAndUserName()
    {
        string userName = null;

        if (Request.HttpContext.User.Identity.IsAuthenticated)
        {
            return Request.HttpContext.User.Identity.Name;
        }

        if (Request.Cookies.ContainsKey(Constants.BASKET_COOKIENAME))
        {
            userName = Request.Cookies[Constants.BASKET_COOKIENAME];

            if (!Request.HttpContext.User.Identity.IsAuthenticated)
            {
                if (!Guid.TryParse(userName, out var _))
                {
                    userName = null;
                }
            }
        }
        if (userName != null) return userName;

        userName = Guid.NewGuid().ToString();
        var cookieOptions = new CookieOptions { IsEssential = true };
        cookieOptions.Expires = DateTime.Today.AddYears(10);
        Response.Cookies.Append(Constants.BASKET_COOKIENAME, userName, cookieOptions);

        return userName;
    }
}

src/Web/Pages/Basket/Success.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace Microsoft.eShopWeb.Web.Pages.Basket;

[Authorize]
public class SuccessModel : PageModel
{
    public void OnGet()
    {

    }
}

src/Web/Pages/Basket/Checkout.cshtml
@page
@model CheckoutModel
@{
    ViewData["Title"] = "Checkout";
}
<section class="esh-catalog-hero">
    <div class="container">
        <img class="esh-catalog-title" src="~/images/main_banner_text.png" />
    </div>
</section>

<div class="container">
    <h1>Review</h1>
    @if (Model.BasketModel.Items.Any())
    {
        <form asp-page="Checkout" method="post">
            <article class="esh-basket-titles row">
                <br />
                <section class="esh-basket-title col-xs-3">Product</section>
                <section class="esh-basket-title col-xs-3 hidden-lg-down"></section>
                <section class="esh-basket-title col-xs-2">Price</section>
                <section class="esh-basket-title col-xs-2">Quantity</section>
                <section class="esh-basket-title col-xs-2">Cost</section>
            </article>
            <div class="esh-catalog-items row">
                <div asp-validation-summary="All" class="text-danger"></div>
                @for (int i = 0; i < Model.BasketModel.Items.Count; i++)
                {
                    var item = Model.BasketModel.Items[i];
                    <article class="esh-basket-items row">
                        <div>
                            <section class="esh-basket-item esh-basket-item--middle col-lg-3 hidden-lg-down">
                                <img class="esh-basket-image" src="@item.PictureUrl" />
                            </section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-3">@item.ProductName</section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-2">$ @item.UnitPrice.ToString("N2")</section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-2">
                                <input type="hidden" name="@("Items[" + i + "].Id")" value="@item.Id" />
                                <input type="hidden" name="@("Items[" + i + "].Quantity")" value="@item.Quantity" />
                                @item.Quantity
                            </section>
                            <section class="esh-basket-item esh-basket-item--middle esh-basket-item--mark col-xs-2">$ @Math.Round(item.Quantity * item.UnitPrice, 2).ToString("N2")</section>
                        </div>
                        <div class="row">

                        </div>
                    </article>
                }

                <div class="container">
                    <article class="esh-basket-titles esh-basket-titles--clean row">
                        <section class="esh-basket-title col-xs-10"></section>
                        <section class="esh-basket-title col-xs-2">Total</section>
                    </article>

                    <article class="esh-basket-items row">
                        <section class="esh-basket-item col-xs-10"></section>
                        <section class="esh-basket-item esh-basket-item--mark col-xs-2">$ @Model.BasketModel.Total().ToString("N2")</section>
                    </article>

                    <article class="esh-basket-items row">
                        <section class="esh-basket-item col-xs-7"></section>
                    </article>
                </div>
                <div class="row">
                    <section class="esh-basket-item col-xs-1">
                        <a asp-page="Index" class="btn esh-basket-checkout text-white">[ Back ]</a>
                    </section>
                    <section class="esh-basket-item col-xs-push-7 col-xs-4 text-right">
                        <input type="submit" class="btn esh-basket-checkout" value="[ Pay Now ]" />
                    </section>
                </div>
            </div>
        </form>
    }
    else
    {
        <h3 class="esh-catalog-items row">
            Basket is empty.
        </h3>

        <section class="esh-basket-item">
            <a asp-page="/Index" class="btn esh-basket-checkout text-white">[ Continue Shopping ]</a>
        </section>
    }
</div>

src/Web/Pages/Basket/Index.cshtml
@page "{handler?}"
@model IndexModel
@{
    ViewData["Title"] = "Basket";
}
<section class="esh-catalog-hero">
    <div class="container">
        <img class="esh-catalog-title" src="~/images/main_banner_text.png" />
    </div>
</section>

<div class="container">

    @if (Model.BasketModel.Items.Any())
    {
        <form method="post">
            <article class="esh-basket-titles row">
                <br />
                <section class="esh-basket-title col-xs-3">Product</section>
                <section class="esh-basket-title col-xs-3 hidden-lg-down"></section>
                <section class="esh-basket-title col-xs-2">Price</section>
                <section class="esh-basket-title col-xs-2">Quantity</section>
                <section class="esh-basket-title col-xs-2">Cost</section>
            </article>
            <div class="esh-catalog-items row">
                <div asp-validation-summary="All" class="text-danger"></div>
                @for (int i = 0; i < Model.BasketModel.Items.Count; i++)
                {
                    var item = Model.BasketModel.Items[i];
                    <article class="esh-basket-items row">
                        <div>
                            <section class="esh-basket-item esh-basket-item--middle col-lg-3 hidden-lg-down">
                                <img class="esh-basket-image" src="@item.PictureUrl" />
                            </section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-3">@item.ProductName</section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-2">$ @item.UnitPrice.ToString("N2")</section>
                            <section class="esh-basket-item esh-basket-item--middle col-xs-2">
                                <input type="hidden" name="@("Items[" + i + "].Id")" value="@item.Id" />
                                <input type="number" class="esh-basket-input" min="0" name="@("Items[" + i + "].Quantity")" value="@item.Quantity" />
                            </section>
                            <section class="esh-basket-item esh-basket-item--middle esh-basket-item--mark col-xs-2">$ @Math.Round(item.Quantity * item.UnitPrice, 2).ToString("N2")</section>
                        </div>
                        <div class="row">

                        </div>
                    </article>
                }

                <div class="container">
                    <article class="esh-basket-titles esh-basket-titles--clean row">
                        <section class="esh-basket-title col-xs-10"></section>
                        <section class="esh-basket-title col-xs-2">Total</section>
                    </article>

                    <article class="esh-basket-items row">
                        <section class="esh-basket-item col-xs-10"></section>
                        <section class="esh-basket-item esh-basket-item--mark col-xs-2">$ @Model.BasketModel.Total().ToString("N2")</section>
                    </article>

                    <article class="esh-basket-items row">
                        <section class="esh-basket-item col-xs-7"></section>
                    </article>
                </div>
                <div class="row">
                    <section class="esh-basket-item col-xs-1">
                        <a asp-page="/Index" class="btn esh-basket-checkout text-white">[ Continue Shopping ]</a>
                    </section>
                    <section class="esh-basket-item col-xs-push-7 col-xs-4">

                        <button class="btn esh-basket-checkout" name="updatebutton" value="" type="submit"
                                asp-page-handler="Update">
                            [ Update ]
                        </button>
                        <a asp-page="./Checkout" class="btn esh-basket-checkout">[ Checkout ]</a>
                    </section>
                </div>
            </div>
        </form>
    }
    else
    {
        <h3 class="esh-catalog-items row">
            Basket is empty.
        </h3>

        <section class="esh-basket-item">
            <a asp-page="/Index" class="btn esh-basket-checkout text-white">[ Continue Shopping ]</a>
        </section>
    }
</div>

src/Web/Pages/Basket/Success.cshtml
@page
@model SuccessModel
@{
    ViewData["Title"] = "Checkout Complete";
}

<section class="esh-catalog-hero">
    <div class="container">
        <img class="esh-catalog-title" src="~/images/main_banner_text.png" />
    </div>
</section>

<div class="container">
    <h1>Thanks for your Order!</h1>

    <a asp-page="/Index">Continue Shopping...</a>
</div>